"""Create array
===============

This demo shows the features of ``numpy`` (https://numpy.org/doc/stable/user/quickstart.html).
"""

import numpy as np
import matplotlib.pyplot as plt

# sphinx_gallery_thumbnail_path = '11_demos/_static/_thumb/demoNumpy.png'

array = np.arange(15).reshape(3, 5)

###############################################################################
array.shape

###############################################################################
array.ndim

###############################################################################
array.dtype.name

###############################################################################
array.itemsize

###############################################################################
array.size

###############################################################################
type(array)

###############################################################################
# **dtype, dimensions**
array2 = np.array([1.2, 3.5, 5.1])
array2.dtype.name

###############################################################################
np.array([(1.5, 2, 3), (4, 5, 6)])

###############################################################################
np.array([[1, 2], [3, 4]], dtype=complex)

###############################################################################
# **Zeros, ones, empty**
np.zeros((3, 4))

###############################################################################
np.ones((2, 3, 4), dtype=np.int16)

###############################################################################
np.empty((2, 10))

###############################################################################
# **Sequence of numbers**
np.arange(10, 30, 5)
np.arange(0, 2, 0.3)

###############################################################################
np.linspace(0, 2, 9)

###############################################################################
x = np.linspace(0, 2 * np.pi, 100)
f = np.sin(x)

plt.figure()
plt.plot(f)
plt.show()

###############################################################################
# **Reshape**
np.arange(12).reshape(4, 3)

###############################################################################
c = np.arange(24).reshape(2, 3, 4)
